'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _coreGetExports = require('../core/getExports');

var _coreGetExports2 = _interopRequireDefault(_coreGetExports);

module.exports = function (context) {
  function message(node, errors) {
    var m = 'Errors encountered while analysing imported module \'' + node.source.value + '\'.';

    if (context.options[0] === 'include-messages') {
      m += '\n' + errors.join('\n');
    } else if (context.options[0] === 'include-stack') {
      m += '\n' + errors.map(function (e) {
        return e.stack;
      }).join('\n');
    }

    return m;
  }

  return {
    'ImportDeclaration': function ImportDeclaration(node) {
      var imports = _coreGetExports2['default'].get(node.source.value, context);
      if (imports == null) return;

      if (imports.errors.length > 0) {
        context.report(node.source, message(node, imports.errors));
      }
    }
  };
};