'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _coreGetExports = require('../core/getExports');

var _coreGetExports2 = _interopRequireDefault(_coreGetExports);

module.exports = function (context) {
  return {
    'CallExpression': function CallExpression(call) {
      if (call.callee.type !== 'Identifier') return;
      if (call.callee.name !== 'require') return;

      if (call.arguments.length !== 1) return;
      var module = call.arguments[0];

      if (module.type !== 'Literal') return;
      if (typeof module.value !== 'string') return;

      var imports = _coreGetExports2['default'].get(module.value, context);
      if (!imports || imports.hasDefault || imports.hasNamed) {
        context.report(call.callee, 'CommonJS require of ES module \'' + module.value + '\'.');
      }
    }
  };
};